/*
 * Copyright 2018 Equilinox Mod Kit Project
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *    the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package equilinoxmodkit.experimental;


import org.lwjgl.input.Keyboard;
import toolbox.MyKeyboard;

import java.security.Key;


/**
 * <i>!!! EXPERIMENTAL !!!</i><br>
 * Static class that provides methods to check if keys are pressed and simulate key presses.
 *
 * @author EMK Team
 */
public final class EmkKeyboard {
	
	
	public static final int
			KEY_A = Keyboard.KEY_A,
			KEY_B = Keyboard.KEY_B,
			KEY_C = Keyboard.KEY_C,
			KEY_D = Keyboard.KEY_D,
			KEY_E = Keyboard.KEY_E,
			KEY_F = Keyboard.KEY_F,
			KEY_G = Keyboard.KEY_G,
			KEY_H = Keyboard.KEY_H,
			KEY_I = Keyboard.KEY_I,
			KEY_J = Keyboard.KEY_J,
			KEY_K = Keyboard.KEY_K,
			KEY_L = Keyboard.KEY_L,
			KEY_M = Keyboard.KEY_M,
			KEY_N = Keyboard.KEY_N,
			KEY_O = Keyboard.KEY_O,
			KEY_P = Keyboard.KEY_P,
			KEY_Q = Keyboard.KEY_Q,
			KEY_R = Keyboard.KEY_R,
			KEY_S = Keyboard.KEY_S,
			KEY_T = Keyboard.KEY_T,
			KEY_U = Keyboard.KEY_U,
			KEY_V = Keyboard.KEY_V,
			KEY_W = Keyboard.KEY_W,
			KEY_X = Keyboard.KEY_X,
			KEY_Y = Keyboard.KEY_Y,
			KEY_Z = Keyboard.KEY_Z;
	public static final int
			KEY_ESCAPE = Keyboard.KEY_ESCAPE,
			KEY_TAB = Keyboard.KEY_TAB,
			// KEY_CAPS_LOCK = Keyboard.
			KEY_LSHIFT = Keyboard.KEY_LSHIFT,
			KEY_LCONTROL = Keyboard.KEY_LCONTROL,
			KEY_LSUPER = Keyboard.KEY_LMETA,
			// KEY_LALT = Keyboard.
			KEY_SPACE = Keyboard.KEY_SPACE,
			// KEY_ALT_GR = Keyboard.
			KEY_RSUPER = Keyboard.KEY_RMETA,
			KEY_RCONTROL = Keyboard.KEY_RCONTROL,
			KEY_RSHIFT = Keyboard.KEY_RSHIFT,
			KEY_ENTER = Keyboard.KEY_RETURN,
			KEY_BACKSPACE = Keyboard.KEY_BACK;
	public static final int
			KEY_F1 = Keyboard.KEY_F1,
			KEY_F2 = Keyboard.KEY_F2,
			KEY_F3 = Keyboard.KEY_F3,
			KEY_F4 = Keyboard.KEY_F4,
			KEY_F5 = Keyboard.KEY_F5,
			KEY_F6 = Keyboard.KEY_F6,
			KEY_F7 = Keyboard.KEY_F7,
			KEY_F8 = Keyboard.KEY_F8,
			KEY_F9 = Keyboard.KEY_F9,
			KEY_F10 = Keyboard.KEY_F10,
			KEY_F11 = Keyboard.KEY_F11,
			KEY_F12 = Keyboard.KEY_F12;
	
	
	/** Private constructor because of statically used class. */
	private EmkKeyboard() {
	}
	
	
	public static boolean isKeyDown( int key ) {
		return MyKeyboard.getKeyboard().isKeyDown( key );
	}
	
	public static void invokeKey( int button ) {
	
	}
	
	
}
